/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 02 - solution (3-1)
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdlib.h>
#include "list.h"

list_t *list_insert_in_order(list_t *head, char *surname, char *name)
{
  list_t *ptr, *node;

  node = (list_t *) malloc (sizeof(list_t));
  if (node==NULL) {
    fprintf (stderr, "Memory allocation error.\n");
    exit(EXIT_FAILURE);
  }
  node->surname = strdup (surname);
  node->name = strdup (name);

  /* insertion ahead */
  if (head==NULL || strcmp(surname, head->surname)<0 ||
     (strcmp(surname, head->surname)==0 && strcmp(name, head->name)<0)
     ) {
    node->next = head;
    return node;
  }

  /* insertion in the middle (or at the end) */
  ptr = head; 
  while (ptr->next!=NULL && (strcmp(surname, ptr->next->surname)>0 ||
    (strcmp(surname, ptr->next->surname)==0 && strcmp(name, ptr->next->name)>0))
    ) {
    ptr = ptr->next;
  }
  node->next = ptr->next;
  ptr->next = node;

  return head;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
