/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 05 - solution (3-1)
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#ifndef _GRAPH
#define _GRAPH

#include "symbolTable.h"

typedef struct edge_s {
  int v;
  int w;
  int wt;
} edge_t;

typedef struct graph_s *graph_t;

edge_t edge_init(int, int, int);
graph_t graph_init(int);
void graph_edge_insert(graph_t, edge_t);
int graph_edges(edge_t [], graph_t);
void graph_write(graph_t, st_t);
int graph_regular(graph_t);
edge_t *path_find(graph_t, int, int*, int*);
void graph_dispose(graph_t);

#endif

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
