/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 06 - solution (3-1)
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include "impl2.h"

void list_insert (node_t **left, node_t **right, int key, int leftRight) {
  node_t *p;

  // Node allocation and field initialization 
  p = malloc (1 * sizeof (node_t));
  if (p==NULL) {
    fprintf (stderr, "Memory allocation error.\n");
    exit(EXIT_FAILURE);
  }
  p->key = key;

  // Node insertion
  if (leftRight==0) {
    p->right = *left;
    p->left = NULL;
    if (*left != NULL) {
      (*left)->left = p;
    }
    *left = p;     
    if (*right == NULL) {
      *right = *left;
    }
  } else {
    p->left = *right;
    p->right = NULL;
    if (*right != NULL) {
      (*right)->right = p;
    }
    *right = p;
    if (*left == NULL) {
      *left = *right;
    }
  }

  return;
}

void list_write (node_t *left, node_t *right, int leftRight) {
  node_t *p;

  if (leftRight==0) {
    fprintf (stdout, "Left2Right: ");
    p = left;
    while (p!=NULL) {
      fprintf (stdout, "%d ", p->key);
      p = p->right;
    }
    fprintf (stdout, "\n");
  } else {
    fprintf (stdout, "Right2Left: ");
    p = right;
    while (p!=NULL) {
      fprintf (stdout, "%d ", p->key);
      p = p->left;
    }
    fprintf (stdout, "\n");
  }

  return;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
