/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 06 - solution (4-1)
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>

static void menu_create_r (char ***, int, char **, int);

void menu_create (char ***data, int n) {
  char **v;

  v = malloc (n * sizeof (char **));
  if (v==NULL) {
    fprintf (stdout, "Memory allocation error.\n");
    exit(EXIT_FAILURE);
  }

  menu_create_r (data, n, v, 0);

  free (v);

  return;
}

static void menu_create_r (char ***data, int n, char **v, int l) {
  int i;
  static int nSol = 1;

  if (l==n) {
    fprintf (stdout, "Menu %2d: ", nSol);
    for (i=0; i<n; i++) {
      fprintf (stdout, "%s ", v[i]);
    }
    fprintf (stdout, "\n");
    nSol++;
    return;
  }

  i=0;
  while (data[l][i]!=NULL) {
    v[l] = data[l][i];
    menu_create_r (data, n, v, l+1);
    i++;
  }

  return;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
