/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 08 - solution (3-1)
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include "impl2.h"

/*
 *  Iff not 0 use the strcnp function to copy a substring;
 *  otherwise copy char by char
 */
#define USE_STRNCPY 1

node_t *string_split (char *str) {
  node_t *top, *p;
  int startPos, endPos;

  top = NULL;
  startPos = endPos = 0;
  while (endPos<strlen(str)) {
    while (endPos<strlen(str) && str[endPos]!='.') {
      endPos++;
    }

    // Allocate a new node
    p = malloc(1 * sizeof(node_t));
    if (p == NULL) {
      fprintf (stderr, "Memory allocation error.\n");
      exit(EXIT_FAILURE);
    }
    p->str = malloc ((endPos-startPos+1) * sizeof(char));
#if USE_STRNCPY
    // Copy string with strncpy
    strncpy (p->str, &str[startPos], (endPos-startPos));
    endPos++;
    startPos = endPos;
#else
    // Copy string explicitly (without strncpy)
    {
      int i = 0;
      while (startPos<endPos) {
        p->str[i] = str[startPos];
        i++;
        startPos++;
      }
      p->str[i] = '\0';
      endPos++;
      startPos = endPos;
    }
#endif
    p->next = top;
    top = p;
  }

  return top;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
