/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 12 - solution (3-1)
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include "impl2.h"

static void path_write_r (struct node *, int, int, struct node **);

void path_write (struct node *root, int height) {
  struct node **vet;
  int i;

  vet = (struct node **) malloc (height * sizeof (struct node *)); 
  for (i=0; i<height; i++) {
    vet[i] = NULL;
  }

  path_write_r (root, height, 0, vet);

  free (vet);

  return;
}

static void path_write_r (struct node *root, int height, int level, struct node **vet) {
  int i;

  if (root==NULL) {
     return;
  }

  if (root->left==NULL && root->right==NULL) {
    // This is a leaf
    fprintf (stdout, "Path: ");
    for (i=0; i<=height; i++) {
      if (vet[i]!=NULL) {
        fprintf (stdout, "%d ", vet[i]->key);
      }
    }
    // This node
    fprintf (stdout, "%d ", root->key);
    fprintf (stdout, "\n");
    return; 
  }

  vet[level] = root; 
  path_write_r (root->left, height, level+1, vet);
  path_write_r (root->right, height, level+1, vet);
  vet[level] = NULL; 

  return;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
