/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 16 - solution (2-1)
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

void chess (int **mat, int n) {
  int r, c, rr, cc;
  int sum, max, rBest, cBest;

  max = rBest = cBest = (-1);
  for (r=0; r<n; r++) {
    for (c=0; c<n; c++) {
      if (mat[r][c]==0) {
        sum = 0;
        for (rr=r, cc=c; rr>=0 && cc>=0; rr--, cc--) {
          sum += mat[rr][cc];
        }
        for (rr=r, cc=c; rr>=0 && cc<n; rr--, cc++) {
          sum += mat[rr][cc];
        }
        for (rr=r, cc=c; rr<n && cc>=0; rr++, cc--) {
          sum += mat[rr][cc];
        }
        for (rr=r, cc=c; rr<n && cc<n; rr++, cc++) {
          sum += mat[rr][cc];
        }
        if (sum>max) {
          max = sum;
          rBest = r;
          cBest = c;
        }
      }
    }
  }

  fprintf (stdout, "Bishop coordinates (%d, %d) sum (%d) \n", rBest, cBest, max);

  return;
}


/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
