/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 16 - solution (4-1)
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#define N 3

static void mat_copy (int [N][N], int [N][N], int);

void path (
  int mat[N][N], int matSize, int r, int c, int visitedBest[N][N],
  int visited[N][N], int *pathSumMax, int pathSumCurrent, int *pathLenMax,
  int pathLenCurrent) {
  int dx[8] = {-1, -1, -1, 0, 0, +1, +1, +1};
  int dy[8] = {-1, 0, +1, -1, +1, -1, 0, +1};
  int i, v1, v2;

  // We are outside the matrix ... return
  if (r<0 || r>=matSize || c<0 || c>=matSize) {
    return;
  }

  // Element already visited ... return
  if (visited[r][c]>0) {
    return;
  }

  // Compute new cost and check solution
  v1 = pathSumCurrent + mat[r][c];
  v2 = pathLenCurrent + 1;

  if (r==(matSize-1) && c==(matSize-1)) {
    if ( (v1>*pathSumMax) || ((v1==*pathSumMax) && (v2<*pathLenMax)) ) {
      *pathSumMax = v1,
      *pathLenMax = v2;
      mat_copy (visitedBest, visited, matSize);
      visitedBest[r][c] = *pathLenMax;
    }

    return;
  }

  // Mark element as visited
  visited[r][c] = v2;

  // Recur on all adjacent elements
  for (i=0; i<8; i++) {
    path (mat, matSize, r+dx[i], c+dy[i], visitedBest, visited,
         pathSumMax, v1, pathLenMax, v2);
  }

  // Unmark (backtrack)
  visited[r][c] = 0;

  return;
}

/*
 *  Copy current into best solution
 */
static void mat_copy (int m1[N][N], int m2[N][N], int n) {
  int r, c;

  for (r=0; r<n; r++) {
    for (c=0; c<n; c++) {
      m1[r][c] = m2[r][c];
    }
  }
  
  return;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
