/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 18 - solution (2-1)
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Version 1: Quadratic Cost */
char *char_erase_ver1 (char *str, int *pos) {
  char *s;
  int i, j, k;

  s = (char *) malloc ((strlen (str) + 1) * sizeof (char));
  if (s==NULL) {
    fprintf (stderr, "Memory allocation error.\n");
    exit(EXIT_FAILURE);
  }
  for (i=k=0; i<strlen(str); i++) {
    for (j=0; pos[j]!=(-1) && pos[j]!=i; j++);
    if (pos[j]==(-1)) {
      s[k] = str[i];
      k++;
    }
  }
  s[k] = '\0';

  return (s);
}

/* Version 2: Linear Cost */
char *char_erase_ver2 (char *str, int *pos) {
  char *s;
  int i, j;

  s = (char *) malloc ((strlen (str) + 1) * sizeof (char));
  if (s==NULL) {
    fprintf (stderr, "Memory allocation error.\n");
    exit(EXIT_FAILURE);
  }
  for (i=0; i<strlen(str)+1; i++)
    s[i] = '1';
  for (i=0; pos[i]!=(-1); i++) {
    s[pos[i]] = '0';
  }
  for (i=j=0; i<strlen(str)+1; i++) {
    if (s[i]=='1') {
      s[j] = str[i];
      j++;
    }
  }

  return (s);
}

/*
 *  Version 3
 *  IF AND ONLY IF the array pos is SORTED in ASCENDING ORDER
 *  it is also possible to use the following version
 */
char *char_erase_ver3 (char *str, int *pos) {
  int i, j, k;
  int n = strlen(str)+1;
  char *s;

  s = (char *) malloc (n * sizeof (char));
  if (s==NULL) {
    fprintf (stderr, "Memory allocation error.\n");
    exit(EXIT_FAILURE);
  }
  for(i=0, j=0, k=0; i<n; i++) {
    if (pos[j] != -1 && i == pos[j]) {
      j++;
      continue;
    }
    s[k++] = str[i];
  }
  s[k] = '\0';

  return (s);
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
