/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 18 - solution (3-1)
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include "impl2.h"

static void visitRow (struct rt *, float, int);
static struct rt *create (float, int, int, struct rt *);

void mat_insert (
  struct mt *m, int row, int column, float value
) {
  struct rt *rp1;

  rp1 = m->rp;

  // Corner case: The matrix is empty
  if (rp1==NULL || row<rp1->r) {
    m->rp = create (value, row, column, rp1);

    return;
  }

  // Corner case: The correct row is the first one
  if (rp1->r == row) {
    visitRow (rp1, value, column);
  }

  // Look-for the right row
  while (rp1->rp!=NULL && rp1->rp->r<row) {
    rp1 = rp1->rp;
  }

  // If this row is empty ... create a new row element
  if (rp1->rp == NULL) {
    rp1->rp = create (value, row, column, rp1->rp);
    return;
  }
  // ... otherwise visit the row
  if (rp1->rp->r == row) {
    visitRow (rp1->rp, value, column);
  } else {
    rp1->rp = create (value, row, column, rp1->rp);
  }

  return;
}

/*
 *  Create e new matrix element
 */
static struct rt *create (
  float value, int row, int column, struct rt *p
) {
  struct rt *rp;
  struct et *ep;

  rp = (struct rt *) malloc (sizeof (struct rt));
  ep = (struct et *) malloc (sizeof (struct et));
  if (rp==NULL || ep==NULL) {
    fprintf (stderr, "AllocatioN Erro.\n");
    exit(EXIT_FAILURE);
  } 
  rp->r = row;
  rp->rp = p;
  rp->ep = ep;
  ep->c = column;
  ep->val = value;
  ep->ep = NULL;

  return (rp);
}

/*
 *  Visit a horizontal list (a matrix rom)
 */
static void visitRow (struct rt *rp, float value, int column) {
  struct et *ep1, *ep2;

  ep1 = rp->ep;
  if (ep1==NULL || column<ep1->c) {
    ep2 = (struct et *) malloc (sizeof (struct et));
    ep2->c = column;
    ep2->val = value;
    ep2->ep = rp->ep;
    rp->ep = ep2;

    return;
  }

  if (ep1->c == column) {
    ep1->val = value;
  }

  while (ep1->ep!=NULL && ep1->ep->c<column) {
    ep1 = ep1->ep;
  }

  if (ep1->ep == NULL) {
    ep2 = (struct et *) malloc (sizeof (struct et));
    ep2->c = column;
    ep2->val = value;
    ep2->ep = NULL;

    ep1->ep = ep2;
  }
  if (ep1->ep->c == column) {
    ep1->val = value;
  } else {
    // Insert New Element
    ep2 = (struct et *) malloc (sizeof (struct et));
    ep2->c = column;
    ep2->val = value;
    ep2->ep = ep1->ep;

    ep1->ep = ep2;
  }

  return;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
