/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 20 - solution (4-1)
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define SIZE  10
#define EMPTY  0
#define FULL   1

#define NS  4
#define NB  5

void switchAndBulb_ver1 (int [][NB], int, int, int *, int *, int *, int);
int switchAndBulb_ver2 (int [][NB], int, int, int *, int, int, int);
  
int main (
  int argc,
  char *argv[]
  )
{
  int nBest = NS+1;
  int mat[NS][NB] = {{1, 1, 1, 0, 1},
                     {1, 0, 1, 0, 0},
                     {0, 1, 1, 1, 0},
                     {0, 0, 0, 1, 0},
                    };
  int switchBest[NS] = {0, 0, 0, 0};
  int switchCurrent[NS] = {0, 0, 0, 0};
  int i, k, found;

  // Version 1
  fprintf (stdout, "Version 1: ");
  switchAndBulb_ver1 (mat, NS, NB, &nBest, switchBest, switchCurrent, 0);
  if (nBest>NS) {
    fprintf (stdout, "No solution found.\n");
  } else {
    fprintf (stdout, "Solution found; ");
    fprintf (stdout, "%d Switches on -> ", nBest);
    for (i=0; i<NS; i++) {
      if (switchBest[i]==1)
        fprintf (stdout, "%d ", i);
    }
    fprintf (stdout, "\n");
  }

  // Version 2
  fprintf (stdout, "Version 2: ");
  found = 0;
  for (k=1; k<=NS && found==0; k++) {
    if (switchAndBulb_ver2 (mat, NS, NB, switchCurrent, 0, k, 0) == 1) {
      found = 1;
    }
  }
  if (found==0) {
    fprintf (stdout, "No solution found.\n");
  }

  return (1);
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
