/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 21 - solution (2-1)
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include "item.h"
#include "symbolTable.h"
#include "graph.h"

int main(int argc, char **argv) {
  graph_t g = NULL;
  st_t st = NULL;

  if (argc != 2) {
    fprintf (stdout, "Run as: %s <file_in>\n", argv[0]);
    exit(EXIT_FAILURE);
  }

  g = graph_read(argv[1], &st);
  if (g == NULL || st == NULL) {
    fprintf (stderr, "Error while reading the graph.\n");
    exit(EXIT_FAILURE);
  }

  graph_max_path_find(g, st);
  graph_subset_find(g, st);

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
