/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 21 - solution (2-1)
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "item.h"
#include "bst.h"
#include "symbolTable.h"

struct st_s {
  item_t *v;
  bst_t lookup;
  int maxN;
  int N;
};

st_t st_init(int maxN) {
  st_t tab = malloc(sizeof (struct st_s));
  tab->v = malloc(maxN * sizeof (item_t));
  tab->maxN = maxN;
  tab->N = 0;
  tab->lookup = bst_init();
  return tab;
}

int st_search(st_t tab, char *key) {
  return bst_search(tab->lookup, key);
}

int st_get_num(st_t tab) {
  return tab->N;
}

int st_insert(st_t tab, char *name, int color) {
  int id = tab->N;
  if (tab->N >= tab->maxN) {
    tab->v = realloc(tab->v, (2*tab->maxN)*sizeof(item_t));
    if (tab->v == NULL)
      return -1;
    tab->maxN = 2*tab->maxN;
  }
  tab->v[id].name = strdup(name);
  tab->v[id].color = color;
  bst_insert_leaf(tab->lookup, name, id);
  tab->N++;
  return id;
}

int  st_get_color(st_t t, int i) {
  return (t->v[i].color);
}

char *st_get_name(st_t t, int i) {
  return (t->v[i].name);
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
