/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 24 - solution (3-1)
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include "impl2.h"

static int visit (node_t *, int);

/* Version 1: This version works on BSTs */
int visit_ver1 (node_t *root, int key1, int key2) {
  int d, d_left, d_right;
  
  if (root == NULL) {
    return (0);
  }

  if (key1<root->key && key2<root->key) {
    d = visit_ver1 (root->left, key1, key2);
  } else {
    if (key1>root->key && key2>root->key) {
      d = visit_ver1 (root->right, key1, key2);
    } else {
      d_left = visit (root, key1);
      d_right = visit (root, key2);
      d = d_left + d_right;
    }
  }

  return (d);
}

static int visit (node_t *root, int key) {
  int d;

  if (root == NULL) {
    return (-1);
  }

  if (key<root->key) {
    d = visit (root->left, key);
    if (d>-1) {
      return (d+1);
    }
  }

  if (key>root->key) {
    d = visit (root->right, key);
    if (d>-1) {
      return (d+1);
    }
  }

  return (0);
}

/* Version 2: Plain binaries tree (non BSTs) */
int visit_ver2 (node_t *root, int key1, int key2) {
  int t_right, t_left, t_here;
  
  t_here = 0;
  t_right = t_left = 0;

  if (root != NULL) {
    if (key1==root->key || key2==root->key) {
      t_here = 1;
    }
    t_left = visit_ver2 (root->left, key1, key2);
    t_right = visit_ver2 (root->right, key1, key2);
    if (t_left && t_right) {
      /*
       *  Splitting node; one child on the left and one on the right
       *  As for the BST version distance = left + right height
       */
      fprintf (stdout, "Distance between %d and %d: ", key1, key2);
      fprintf (stdout, "%d edges\n", t_left+t_right);
    } else if (t_left || t_right) {
      if (t_here) {
        /*
         *  One child on the left or on the right the other on this node
         *  I return t_left if it is on the left and t_right if it is on the right,
         *  i.e., I always return t_left+t_right
	 */
        fprintf (stdout, "Distance between %d and %d: ", key1, key2);
        fprintf (stdout, "%d edges\n", t_left+t_right);
      } else {
        /*
         *  One child is on the left or on the right and the other I do not know
         *  I return t_left+1 or t_right+1, i.e., t_left+t_tight+1 being one = 0
         */
        return t_left + t_right + 1;
      }
    }
  }
  
  return t_here;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
