/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 24 - solution (4-1)
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>

static void birthday_r (int *, int, int, int *, int, int);
static int check (int *, int *, int);

/*
 * Allocate solution array and run recursive function
 */
int birthday (int *vet, int n, int m, int k) {
  int *selection;

  selection = malloc (k * sizeof (int));
  if (selection ==NULL) {
    fprintf (stderr, "Memory allocation error.\n");
    exit(EXIT_FAILURE);
  }

  birthday_r (vet, n, k, selection, 0, 0);

  free (selection);

  return (1);
}

/*
 *  Recur and generate simple combinations
 */
void birthday_r (int *vet, int n, int k, int *selection, int level, int sp) {
  int i;

  if (level==k) {
    if (check(vet, selection, k)==1) {
      for (i=0; i<k; i++) {
        fprintf (stdout, "%d ", selection[i]);
      }
      fprintf (stdout, "\n");
    }
    return;
  }

  for (i=sp; i<n; i++) {
    selection[level] = i;
    birthday_r (vet, n, k, selection, level+1, i+1);
  }

  return;
}

/*
 *  Check condition on current solition
 */
static int check (int *vet, int *selection, int k) {
  int i, j;

  for (i=0; i<k-1; i++) {
    for (j=i+1; j<k; j++) {
      if (vet[selection[i]]==vet[selection[j]]) {
	return (0);
      }
    }
  }

  return 1;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
