/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 25 - solution (2-1)
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#ifndef _QUEUE_PUBLIC
#define _QUEUE_PUBLIC

#include <stdio.h>

/* macro definition */
#define queue_empty_m(qp) (queue_count(qp) == 0)

/* type declarations */
typedef struct queue queue_t;

/* extern function prototypes */
extern queue_t *queue_init(int size);
extern int queue_count(queue_t *sp);
extern int queue_put(queue_t *sp, void *data);
extern int queue_get(queue_t *sp, void **data_ptr);
extern void queue_print(FILE *fp, queue_t *sp, void (*print)(FILE *, void *));
extern void queue_dispose(queue_t *sp, void (*quit)(void *));

#endif

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
