/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 26 - solution (4-1)
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>

int simple_combination(int, int *, int, int, int, int **);
static int **file_read(char *, int *);
static void matrix_write(int **, int);

int main(int argc, char *argv[]) {
  int n, k, i, found=0;

  int **mat = file_read(argv[1], &n);
  int N = 2*n;
  int *sol = calloc(N, sizeof(int));

  fprintf (stdout, "Initial Matrix:\n");
  matrix_write (mat, n);

  for (k=1; k <= N && found==0; k++) {
    if (simple_combination(0, sol, N, k, 0, mat))
      found = 1;
  }
  if (found==0) {
    fprintf (stdout, "No solution found.\n");
  }

  free(sol);
  for (i=0; i < n; i++)
    free(mat[i]);
  free(mat);

  return 0;
}

static int **file_read(char *name, int *n) {
  int i, j, **mat;
  FILE *fp;

  fp = fopen (name, "r");
  if (fp==NULL) {
    fprintf (stderr, "File open error.\n");
    exit(EXIT_FAILURE);
  }
  fscanf(fp, "%d", n);
  mat = calloc(*n, sizeof(int *));

  for (i=0; i<*n; i++) {
    mat[i] = calloc(*n, sizeof(int));
    for (j=0; j<*n; j++) {
      fscanf(fp, "%d", &mat[i][j]);
    }
  }

  fclose (fp);
  return mat;
}

static void matrix_write (int **m, int n) {
  int i, j;

  for (i=0; i<n; i++) {
    for (j=0; j<n; j++)
      fprintf (stdout, "%d ", m[i][j]);
    fprintf (stdout, "\n");
  }

  return;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
