/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 26 - solution (4-1)
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>

static int matrix_check(int **mat, int n, int k, int *sol);

int simple_combination (int pos, int *sol, int N, int k, int start, int **mat) {
  int i, n = N/2;

  if (pos >= k) {
    if (matrix_check(mat, n, k, sol)) {
      fprintf(stdout, "Solution: \n");
      for (i=0; i<k; i++) {
        if (sol[i]<(N/2)) {
          fprintf (stdout, "Row=%d ", sol[i]);
        } else {
          fprintf (stdout, "Column=%d ", sol[i]-(N/2));
        }
      }
      fprintf (stdout, "\n");
      return 1;
    } else {
      return 0;
    }
  }

  for (i=start; i<N; i++) {
    sol[pos] = i;
    if (simple_combination(pos+1, sol, N, k, i+1, mat)) {
      return 1;
    }
  }

  return 0;
}

static int matrix_check(int **mat, int n, int k, int *sol) {
  int i, j, ok, **flipMat;

  flipMat = malloc (n * sizeof(int *));
  if (flipMat == NULL){
    fprintf (stderr, "Memory allocation error.\n");
    exit(EXIT_FAILURE);
  }

  for (i=0; i<n; i++) {
    flipMat[i] = malloc (n * sizeof(int));
    if (flipMat[i] == NULL){
      fprintf (stderr, "Memory allocation error.\n");
      exit(EXIT_FAILURE);
    }
    for (j=0; j<n; j++) {
      flipMat[i][j] = mat[i][j];
    }
  }

  for (i=0; i<k; i++) {
    if (sol[i] < n) {
      for (j=0; j<n; j++) {
        flipMat[sol[i]][j] = (flipMat[sol[i]][j]+1)%2;
      }
    } else {
      for (j=0; j<n; j++) {
        flipMat[j][sol[i]-n] = (flipMat[j][sol[i]-n]+1)%2;
      }
    }
  }

  ok = 1;
  for (i=0; i<n; i++) {
    for(j=0; j<n; j++) {
      ok &= flipMat[i][j];
    }
  }

  for (i=0; i<n; i++) {
    free (flipMat[i]);
  }
  free (flipMat);

  return ok;
}



/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
