/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 27 - solution (2-1)
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "graph.h"

struct graph_s {
  int **madj;
  int vertex_n;
};

int graph_get_nv(graph_t g) {
  if (g != NULL)
    return g->vertex_n;
  return -1;
}

graph_t graph_init(int nV) {
  int i;

  graph_t g = malloc(sizeof(*g));
  if (g == NULL)
    return NULL;
  g->vertex_n = nV;
  g->madj = calloc(nV, sizeof(int*));
  for(i=0;i<nV;i++) g->madj[i] = calloc(nV, sizeof(int));

  return g;
}

void graph_insert_edge(graph_t g, int src, int dst) {
  if(src < 0 || dst < 0) return;
  if (g->madj == NULL) return;
  g->madj[src][dst] = g->madj[dst][src] = 1;

  return;
}

int graph_check_adjancency(graph_t g, int x, int y) {
  if (g == NULL || g->madj == NULL)
    return 0;
  return g->madj[x][y] != 0;
}

int graph_get_weight(graph_t g, int x, int y) {
  if (g == NULL || g->madj == NULL)
    return 0;
  return g->madj[x][y];
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
