/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 27 - solution (2-1)
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include "list.h"

typedef struct node_s {
  int index;
  struct node_s *next;
} node_t;

struct list_s {
  node_t *head;
  node_t *tail;
};

static node_t *node_create(int index, node_t *next) {
  node_t *n = calloc(1, sizeof(node_t));

  if (n == NULL) {
    fprintf (stderr, "Memory allocation error.\n");
    return NULL;
  }
  n->index = index;
  n->next = next;

  return n;
}

list_t list_init() {
  list_t l = calloc(1, sizeof(*l));

  if (l == NULL) {
    fprintf (stderr, "Memory allocation error.\n");
    return NULL;
  }
  l->head = l->tail = NULL;

  return l;
}

void list_insert_in_order(list_t l, int v) {
  node_t *n;

  if (l == NULL)
    return;
  n = node_create(v, NULL);
  if (l->head == NULL) {
    l->head = l->tail = n;
    return;
   }
  l->tail->next = n;
  l->tail = n;

  return;
}

void list_write(list_t l) {
  node_t *iter;

  if (l == NULL)
    return;
  for (iter = l->head; iter != NULL; iter = iter->next) {
    fprintf (stdout, "%d ", iter->index);
  }
  fprintf (stdout, "\n");

  return;
}

void list_write_name(list_t l, st_t ts) {
  node_t *iter;

  if (l == NULL)
    return;
  for(iter = l->head; iter != NULL; iter = iter->next) {
    fprintf (stdout, "%s ", st_read(ts, iter->index));
  }
  fprintf (stdout, "\n");

  return;
}

void list_2_arrayt(list_t l, int *v, int nEl) {
  int i;
  node_t *iter;

  if (l == NULL)
    return;
  for(i=0, iter=l->head; i<nEl && iter != NULL; i++, iter = iter->next) {
    v[i] = iter->index;
  }

  return;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
