/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 30 - solution (2-1)
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <string.h>

/* Version 1 */
float my_atof_ver1 (char *s) {
  int i, n;
  float f1, f2, f;
  
  n = strlen (s);
  /* Convert integer part */
  f1 = 0;
  for (i=1; i<n && s[i]!='.'; i++) {
    f1 = f1 * 10 + ((int) (s[i]-'0'));
  }
  /* Convert decimal part */
  f2 = 0;
  for (i=n-1; i>=0 && s[i]!='.'; i--) {
    f2 = f2 + ((int) (s[i]-'0'));
    f2 = f2 / 10;
  }
  f = f1 + f2;
  if (s[0]=='-') {
    f = -f;
  }
  
  return f;
}

/* Version 2 */
float my_atof_ver2 (char *s) {
  int i, n;
  float p, f;
  
  n = strlen (s);
  p = 1;
  /* Compute number of decimal digits */
  for (i=n-1; i>=0 && s[i]!='.'; i--) {
    p = p / 10;
  }
  f = 0;
  /* Convert decimal part */
  for (i=n-1; i>=0 && s[i]!='.'; i--) {
    f = f + ((int) (s[i]-'0')) * p;
    p = p * 10;
  }
  i--;
  /* Convert integer part */
  for ( ; i>0; i--) {
    f = f + ((int) (s[i]-'0')) * p;
    p = p * 10;
  }
  if (s[0]=='-') {
    f = -f;
  }
  
  return f;
}

/* Version 3 */
float my_atof_ver3 (char *s) {
  int i, n;
  float p1, p2, f;
  
  n = strlen (s);
  p1 = p2 = 1;
  f = 0;
  /* Conver number */
  for (i=n-1; i>0; i--) {
    if (s[i]=='.') {
      p2 = p1;
    } else {
      f = f + ((int) (s[i]-'0')) * p1;
      p1 = p1 * 10;
    }
  }
  /* Fix decimal point */
  f = f / p2;
  if (s[0]=='-') {
    f = -f;
  }
  
  return f;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
