/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 30 - solution (3-1)
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include "impl2.h"

static void visit_ver1 (bst_t *, list1_t *, list2_t **);
static void visit_ver2 (bst_t *, list1_t *, list2_t **);
static void queue_put (bst_t *, list1_t *, list2_t **);
static void stack_push (bst_t *, list1_t *, list2_t **);

/* Version 1 */
void bst2list_ver1 (bst_t *root, list2_t **l2) {
  if (root == NULL) {
    return;
  }

  bst2list_ver1 (root->left, l2);
  visit_ver1 (root, root->next, l2);
  bst2list_ver1 (root->right, l2);
  
  return;
}

/* Version 2 */
void bst2list_ver2 (bst_t *root, list2_t **l2) {
  if (root == NULL) {
    return;
  }

  bst2list_ver2 (root->right, l2);
  visit_ver2 (root, root->next, l2);
  bst2list_ver2 (root->left, l2);

  return;
}

static void visit_ver1 (bst_t *bst, list1_t *l1, list2_t **l2) {
  list1_t *p, *min;

  min = NULL;
  for (p=l1; p!=NULL; p=p->next) {
    if (min==NULL || p->price<min->price) {
      min = p;
    }
  }
  queue_put (bst, min, l2);
  return;
}

static void visit_ver2 (bst_t *bst, list1_t *l1, list2_t **l2) {
  list1_t *p, *min;

  min = NULL;
  for (p=l1; p!=NULL; p=p->next) {
    if (min==NULL || p->price<min->price) {
      min = p;
    }
  }
  stack_push (bst, min, l2);
  return;
}

static void queue_put(bst_t *bst, list1_t *l1, list2_t **l2) {
  list2_t *node;

  node = (list2_t *)malloc(sizeof(list2_t));
  if (node==NULL) {
    fprintf (stderr, "Memory allocation error.\n");
    exit(EXIT_FAILURE);
  }
  node->model = bst->model;
  node->dealer = l1->dealer;
  node->price = l1->price;

  if (*l2 == NULL) {
    node->next = node;
  } else {
    node->next = (*l2)->next;
    (*l2)->next = node;
  }
  *l2 = node;

  return;
}

static void stack_push(bst_t *bst, list1_t *l1, list2_t **l2)
{
  list2_t *node;

  node = (list2_t *)malloc(sizeof(list2_t));
  if (node==NULL) {
    fprintf (stderr, "Memory allocation error.\n");
    exit(EXIT_FAILURE);
  }
  node->model = bst->model;
  node->dealer = l1->dealer;
  node->price = l1->price;
  node->next = *l2;
  *l2 = node;

  return;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
