/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 32 - solution (2-1)
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <string.h>

/* Version 1 */
int mat_search_ver1(char **mat, int R, int C, char *str) {
  int r, c, i, l, found, count;

  l = strlen (str);
  count = 0;
  for (r=0; r<R; r++) {
    for (c=0; c<C; c++) {
      /* Horizontal search */
      for (found = 1, i=0; i<l && found==1; i++) {
        if ((c+i)>=C || mat[r][c+i]!=str[i]) {
          found = 0;
	}
      }
      if (found == 1) {
        /* Debug printing
	   fprintf (stdout, "Found H at %d %d\n", r, c);
        */
        count ++;
      }
      /* Vertical search */
      for (found = 1, i=0; i<l && found==1; i++) {
        if ((r+i)>=R || mat[r+i][c]!=str[i]) {
	  found = 0;
	}
      }
      if (found == 1) {
        /* Debug printing
           fprintf (stdout, "Found V at %d %d\n", r, c);
	*/
        count ++;
      }
    }
  }

  return count;
}

/* Version 2 */
int mat_search_ver2(char **mat, int R, int C, char *str) {
  int r, c, i, j, l, found, count;
  int offset[2][2] = {{0,+1},{+1,0}};

  l = strlen (str);
  count = 0;
  for (r=0; r<R; r++) {
    for (c=0; c<C; c++) {
      for (i=0; i<2; i++) {
        for (found = 1, j=0; j<l && found==1; j++) {
          if (((r+j*offset[i][0])>=R || c+j*offset[i][1])>=C || 
	       mat[r+j*offset[i][0]][c+j*offset[i][1]]!=str[j]) {
            found = 0;
  	  }
        }
        if (found == 1) {
          /* Debug printing
	     fprintf (stdout, "Found H at %d %d\n", r, c);
          */
          count ++;
        }
      }
      
    }
  }

  return count;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
