/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 32 - solution (3-1)
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include "impl2.h"

static list2_t *search (list2_t **, char *);
static list1_t *list1_push(list1_t *, char *);
static list2_t *list2_push(list2_t *, char *);

void list_of_list_invert (list1_t *head1, list2_t **head2) {
  list1_t *l1;
  list2_t *l2, *new;

  for (l1=head1; l1!=NULL; l1=l1->next) {
    for (l2=l1->product; l2!=NULL; l2=l2->next) {
      new = search (head2, l2->product);
      if (new == NULL) {
        new = list2_push (*head2, l2->product);
	*head2 = new;
      }
      new->farmer = list1_push (new->farmer, l1->farmer);
    }
  }

  return;
}

static list2_t *search (list2_t **head2, char *product) {
  list2_t *l2;
  
  for (l2=*head2; l2!=NULL; l2=l2->next) {
    if (strcmp(l2->product, product)==0) {
      return l2;
    }
  }

  return NULL;
}

static list1_t *list1_push(list1_t *head, char *farmer) {
  list1_t *node;

  node = (list1_t *) malloc (sizeof (list1_t));
  if (node==NULL) {
    fprintf (stderr, "Memory allocation error.\n");
    exit(EXIT_FAILURE);
  }
  strcpy (node->farmer, farmer);
  node->product = NULL;
  node->next = head;

  return node;
}

static list2_t *list2_push(list2_t *head2, char *product) {
  list2_t *node;

  node = (list2_t *) malloc (sizeof (list2_t));
  if (node==NULL) {
    fprintf (stderr, "Memory allocation error.\n");
    exit(EXIT_FAILURE);
  }
  strcpy (node->product, product);
  node->farmer = NULL;
  node->next = head2;

  return node;
}


/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
