/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 32 - solution (4-1)
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>
#include <limits.h>

static void allocate (int, int, int *, int *, int *, int *, int);
  
void load_balance (int ns, int nt, int *v) {
  int *allocation_current, *allocation_best;
  int i, cost_best;
  
  allocation_current = malloc (nt * sizeof (int));
  allocation_best = malloc (nt * sizeof (int));
  if (allocation_current==NULL || allocation_best==NULL) {
    fprintf (stderr, "Memory allocation error.\n");
    exit(EXIT_FAILURE);
  }

  cost_best = INT_MAX;
  allocate (ns, nt, v, allocation_current, allocation_best, &cost_best, 0);
  fprintf (stdout, "Best allocation: ");
  for (i=0; i<nt; i++) {
    fprintf (stdout, "%d ", allocation_best[i]);
  }
  fprintf (stdout, "; Best Cost = %d\n", cost_best);
    
  free (allocation_current);
  free (allocation_best);
  
  return;
}

static void allocate(
  int ns, int nt, int *v, int *allocation_current, int *allocation_best,
  int *cost_best, int level
  )
{
  int i, *cost, min, max;

  if (level == nt) {
    cost = malloc (ns * sizeof (int));
    if (allocation_current==NULL || allocation_best==NULL) {
      fprintf (stderr, "Memory allocation error.\n");
      exit(EXIT_FAILURE);
    }
    for (i=0; i<ns; i++) {
      cost[i] = 0;
    }
    for (i=0; i<nt; i++) {
      cost[allocation_current[i]] += v[i];
    }
    for (i=0; i<ns; i++) {
      if (i==0 || cost[i]<min) {
        min = cost[i];
      }
      if (i==0 || cost[i]>max) {
        max = cost[i];
      }
    }

    if ((max-min) < (*cost_best)) {
      *cost_best = max-min;
      for (i=0; i<nt; i++) {
        allocation_best[i] = allocation_current[i];
      }
    }
    free (cost);

    return;
  }

  for (i=0; i<ns; i++) {
    allocation_current[level] = i;
    allocate (ns, nt, v, allocation_current, allocation_best, cost_best, level+1);
  }

  return;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
